/*
Blake the Tamaraw
Original Character by RalphJeremy65

Scripting by  Frostiikin
*/


freeslot("SPR2_SLH1", "SPR2_SLH2", "SPR2_GRND",
"SPR_BDRG", "SPR_BBRD", "SPR_BSHA",
"S_SHADOWBIRD", "S_SHADOWDRAGON_HEAD", "S_SHADOWDRAGON_BODY", "S_SHADOWDRAGON_TAIL",  "S_BLAKE_SHADOWBALL",
"MT_BLAKE_SHADOWBIRD", "MT_BLAKE_AFTERIMAGE", "MT_BLAKE_SHADOWDRAGON", "MT_BLAKE_SHADOWDRAGON_TAIL",
"SFX_BLAKSP", "SFX_BLAKWO",
"S_PLAY_BLAKE_SLASH1",  "S_PLAY_BLAKE_SLASH2", "S_PLAY_BLAKE_DASH", "S_PLAY_BLAKE_RIDE", "S_PLAY_BLAKE_PARTNER_RIDE")



states[S_PLAY_BLAKE_SLASH1] = {
	sprite = SPR_PLAY,
	frame = SPR2_SLH1|FF_ANIMATE,
	nextstate = S_PLAY_RUN,
	tics = 12,
	var2 = 4
}

states[S_PLAY_BLAKE_SLASH2] = {
	sprite = SPR_PLAY,
	frame = SPR2_SLH2|FF_ANIMATE,
	nextstate = S_PLAY_RUN,
	tics = 12,
	var2 = 4
}

states[S_PLAY_BLAKE_DASH] = {
	sprite = SPR_PLAY,
	frame = SPR2_DASH|FF_ANIMATE,
	nextstate = S_PLAY_RUN,
	tics = 15,
	var2 = 2
}

states[S_PLAY_BLAKE_RIDE] = {
	sprite = SPR_PLAY,
	frame = SPR2_GRND|FF_ANIMATE,
	nextstate = S_PLAY_FALL,
	tics = -1,
	var2 = 2
}

states[S_PLAY_BLAKE_PARTNER_RIDE] = {
	sprite = SPR_PLAY,
	frame = SPR2_GRND|FF_ANIMATE,
	nextstate = S_PLAY_FALL,
	tics = -1,
	var2 = 2
}

states[S_BLAKE_SHADOWBALL] = {
	sprite = SPR_BSHA,
	frame = A|FF_ANIMATE,
	nextstate = S_INVISIBLE,
	tics = 10,
	var1 = 4,
	var2 = 2
}

states[S_SHADOWBIRD] = {
	sprite = SPR_BBRD,
	frame = A,
	nextstate = S_INVISIBLE,
	tics = -1
}

states[S_SHADOWDRAGON_HEAD] = {
	sprite = SPR_BDRG,
	frame = A,
	nextstate = S_INVISIBLE,
	tics = -1
}

states[S_SHADOWDRAGON_BODY] = {
	sprite = SPR_BDRG,
	frame = B,
	nextstate = S_INVISIBLE,
	tics = -1
}

states[S_SHADOWDRAGON_TAIL] = {
	sprite = SPR_BDRG,
	frame = C,
	nextstate = S_INVISIBLE,
	tics = -1
}

mobjinfo[MT_BLAKE_SHADOWBIRD] = {
	doomednum = -1,
	radius = 5*FRACUNIT,
	height = 5*FRACUNIT,
	spawnstate = S_BLAKE_SHADOWBALL,
	flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_BLAKE_SHADOWDRAGON] = {
	doomednum = -1,
	radius = 5*FRACUNIT,
	height = 5*FRACUNIT,
	spawnstate = S_BLAKE_SHADOWBALL,
	flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_BLAKE_SHADOWDRAGON_TAIL] = {
	doomednum = -1,
	radius = 5*FRACUNIT,
	height = 5*FRACUNIT,
	spawnstate = S_INVISIBLE,
	flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

mobjinfo[MT_BLAKE_AFTERIMAGE] = {
	doomednum = -1,
	radius = 5*FRACUNIT,
	height = 5*FRACUNIT,
	spawnstate = S_BLAKE_SHADOWBALL,
	flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT
}

S_sfx[sfx_blaksp] = {
	singular = false,
	priority = 255,
	flags = 0,
    caption = "Phantom manifesting"
}

spr2defaults[SPR2_GRND] = SPR2_ROLL --WHY THE FUCK DOESN'T THIS WORK

local function NewBlakeVars()
  return {
	slashstate = 0,
	slashtime = 0,
	bird = 0,
	dragon = 0,
	dashangle = 0,
	dragonangle = 0,
	trail1x = 0, --probably a more efficient way to do this
	trail1y = 0, --...but i'm too dumb to think of it
	trail1z = 0,
	trail2x = 0,
	trail2y = 0,
	trail2z = 0,
	trail3x = 0,
	trail3y = 0,
	trail3z = 0,
	follower1 = nil,
	follower2 = nil,
	botjump = 0,
	botoverlay = nil
  }
end
addHook("PreThinkFrame", do
	for p in players.iterate
		if p.mo and p.mo.valid and p.mo.skin == "blake"
			if not p.blake
				p.blake = NewBlakeVars()
			end
		else
			p.blake = nil
		end
	end
end)
addHook("PlayerSpawn", function(p)
	if p.mo and p.mo.valid and p.mo.skin == "blake"
		p.blake = NewBlakeVars()
	else
		p.blake = nil
	end
end)
--setup done, start doing actual things now
addHook("PlayerThink", function(p)
	if not (p and p.mo and p.mo.valid and p.mo.health and p.mo.skin == "blake") return end
		p.blake.slashtime = max($-1, 0)
		if p.blake.slashtime == 0 or p.mo.state == S_PLAY_BLAKE_DASH
			p.blake.slashstate = 0
		end
		/*if p.mo.state == S_PLAY_BLAKE_SLASH1 or p.mo.state == S_PLAY_BLAKE_SLASH2
			P_InstaThrust(p.mo, p.blake.dashangle, 36*p.mo.scale)
			p.drawangle = p.blake.dashangle
		end*/
		if p.mo.state == S_PLAY_BLAKE_DASH
			P_InstaThrust(p.mo, p.blake.dashangle, 52*p.mo.scale)
			p.drawangle = p.blake.dashangle
			--for i = 1, 2
			//spawn particles
				local spooky = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_BLAKE_AFTERIMAGE) //real ghostmobjs have annoying hardcoded transparency stuff so im using my own. slightly more complicated but looks better in the end.
				spooky.angle = p.drawangle
				spooky.skin = p.mo.skin
				spooky.state = p.mo.state
				spooky.scale = p.mo.scale
				spooky.frame = p.mo.frame|FF_TRANS60|FF_FULLBRIGHT
				spooky.blendmode = AST_SUBTRACT
				spooky.color = SKINCOLOR_SUPERPURPLE3
				spooky.colorized = true
				spooky.destscale = 0
				spooky.fuse = 10
				P_SetOrigin(spooky, spooky.x+P_RandomRange(5, -5)*spooky.scale, spooky.y+P_RandomRange(5, -5)*spooky.scale, spooky.z+P_RandomRange(5, -5)*spooky.scale)
				for i = 1, 8 do
					local flame = P_SpawnMobjFromMobj(p.mo, P_RandomRange(15, -15)*p.mo.scale, P_RandomRange(15, -15)*p.mo.scale, P_RandomRange(15, -15)*p.mo.scale+p.mo.height/2, MT_FLAMEPARTICLE)
					flame.colorized = true
					flame.color = SKINCOLOR_PASTEL
					flame.blendmode = AST_SUBTRACT
				end
				
			--end
		end
		if p.mo.state == S_PLAY_BLAKE_SLASH1 or p.mo.state == S_PLAY_BLAKE_SLASH2 or p.mo.state == S_PLAY_BLAKE_DASH
			p.powers[pw_noautobrake] = 2
		end
		//block ability use if you take damage
		if P_PlayerInPain(p) or (p.mo.eflags & MFE_SPRUNG)
			if p.blake.dragon > 0
				p.blake.dragon = max($, 25)
			end
			if p.blake.bird > 0
				p.blake.bird = max($, 25)
			end
		end
		//reset things on ground
		if P_IsObjectOnGround(p.mo) or (p.mo.eflags & MFE_JUSTHITFLOOR) or (p.powers[pw_carry])
			p.blake.bird = 0
			p.blake.dragon = 0
		end
		//BIRD UP
		if p.blake.bird > 0
			p.blake.bird = $+1
			if p.blake.bird < 25
				if p.mo.state != S_PLAY_BLAKE_RIDE
					p.mo.state = S_PLAY_BLAKE_RIDE
				end
				if p.blake.bird < 10
					p.mo.momx = $-$/6
					p.mo.momy = $-$/6
					p.blake.dashangle = p.mo.angle --store the angle you launch at to keep blake's drawangle set to one specific angle during the dash
				end
				if p.blake.bird == 10
					p.blake.dashangle = p.mo.angle
					P_InstaThrust(p.mo, p.blake.dashangle, 56*p.mo.scale)
					--S_StartSound(p.mo, sfx_blakwo)
					P_SpawnGhostMobj(p.mo)
				end
				p.mo.momz = 0
				p.drawangle = p.blake.dashangle
			end
			if p.blake.bird == 26 //cut speed by a lil bit when you exit it, nowhere near as much as the ungodly cuts knuckles & fang have
				P_Thrust(p.mo, R_PointToAngle2(p.mo.x, p.mo.y, p.mo.x-p.mo.momx, p.mo.y-p.mo.momy), FixedHypot(p.mo.momx, p.mo.momy)/5)
				if not P_PlayerInPain(p) and not (p.mo.eflags & MFE_SPRUNG)
					p.mo.state = S_PLAY_FALL
				end
				S_StopSoundByID(p.mo, sfx_blakwo)
			end
		end
		//dragon thingy
		//trail stuff
		p.blake.trail3x = p.blake.trail2x
		p.blake.trail3y = p.blake.trail2y
		p.blake.trail3z = p.blake.trail2z
		p.blake.trail2x = p.blake.trail1x
		p.blake.trail2y = p.blake.trail1y
		p.blake.trail2z = p.blake.trail1z
		p.blake.trail1x = p.mo.x
		p.blake.trail1y = p.mo.y
		p.blake.trail1z = p.mo.z
		//actual logic stuff
		if p.blake.dragon > 0
			p.blake.dragon = $+1
			if p.blake.dragon < 25
				if p.mo.state != S_PLAY_BLAKE_RIDE
					p.mo.state = S_PLAY_BLAKE_RIDE
				end
				//multiplayer shite
				if p.blake.follower1 and p.blake.follower1.valid and p.blake.follower1.health
					p.blake.follower1.player.blakecarry = 2
					p.blake.follower1.player.drawangle = p.drawangle
					P_MoveOrigin (p.blake.follower1, p.blake.trail1x, p.blake.trail1y, p.blake.trail1z)
					if P_IsValidSprite2(p.blake.follower1, SPR2_GRND) --i shouldnt have to do this but this game fucking sucks so whatever
						if p.blake.follower1.state != S_PLAY_BLAKE_PARTNER_RIDE
							p.blake.follower1.state = S_PLAY_BLAKE_PARTNER_RIDE
						end
					else
						if p.blake.follower1.state != S_PLAY_ROLL
							p.blake.follower1.state = S_PLAY_ROLL
						end					
					end
				end
				if p.blake.follower2 and p.blake.follower2.valid and p.blake.follower2.health
					p.blake.follower2.player.blakecarry = 2
					p.blake.follower2.player.drawangle = p.drawangle
					P_MoveOrigin (p.blake.follower2, p.blake.trail2x, p.blake.trail2y, p.blake.trail2z)
					if P_IsValidSprite2(p.blake.follower2, SPR2_GRND) --again, really shouldn't need to do this, but this game fucking hates me
						if p.blake.follower2.state != S_PLAY_BLAKE_PARTNER_RIDE
							p.blake.follower2.state = S_PLAY_BLAKE_PARTNER_RIDE
						end
					else
						if p.blake.follower2.state != S_PLAY_ROLL
							p.blake.follower2.state = S_PLAY_ROLL
						end					
					end
				end
				if p.blake.dragon < 10
					p.mo.momx = $-$/6
					p.mo.momy = $-$/6
					p.blake.dragonangle = p.mo.angle
				end
				if p.blake.dragon == 10 --spawn dragon effects and some other stuff idfk
					p.blake.dragonangle = p.mo.angle
					--S_StartSound(p.mo, sfx_blakwo)
					P_SpawnGhostMobj(p.mo)
					for i = 1, 3
						local trail = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_BLAKE_SHADOWDRAGON_TAIL)
						if i != 3
							trail.state =  S_SHADOWDRAGON_BODY
						else
							trail.state = S_SHADOWDRAGON_TAIL
						end
						trail.target = p.mo
						trail.num = i
					end
				end
				if p.blake.dragon >= 10  --handle some movement stuff 
					P_InstaThrust(p.mo, p.blake.dragonangle, 34*p.mo.scale)
					P_SetObjectMomZ(p.mo, 25*FRACUNIT, false)			
	                local diff = (p.cmd.angleturn<<16 + R_PointToAngle2(0, 0, p.cmd.forwardmove*FRACUNIT, -p.cmd.sidemove*FRACUNIT)) - p.blake.dragonangle
					local factor = 15
					
					if diff and not (p.mo.flags2 & MF2_TWOD) and not (twodlevel)
						if (diff > ANGLE_180)
							diff = InvAngle(InvAngle(diff)/factor)
						else
							diff = $/factor
						end
						
						p.blake.dragonangle = $+diff
					end
				else
					p.mo.momz = 0
					--search for players and get them ready to ride
					local flip = P_MobjFlip(p.mo)
					local dist = 100
					searchBlockmap("objects", function(g, found)
						--if FixedHypot(found.x - p.mo.x, found.y - p.mo.y) < p.mo.radius
						if flip > 0 and found.z > p.mo.z + (p.mo.height*3)
						or flip < 0 and found.z + (found.height*3) < p.mo.z
							return
						end
						if not (found.player) return end
						if (found.player.pflags & PF_JUMPED)
							if p.blake.follower1 == nil
								p.blake.follower1 = found
								found.player.blakecarry = 2
							elseif p.blake.follower2 == nil
								p.blake.follower2= found
								found.player.blakecarry = 2		
							end
						end
					end, p.mo, p.mo.x - dist*p.mo.scale, p.mo.x + dist*p.mo.scale, p.mo.y - dist*p.mo.scale, p.mo.y + dist*p.mo.scale)
				end
				
				p.drawangle = p.blake.dragonangle
			end
			if p.blake.dragon == 25 //cut speed by a lil bit when you exit it, nowhere near as much as the ungodly cuts knuckles & fang have
				P_Thrust(p.mo, R_PointToAngle2(p.mo.x, p.mo.y, p.mo.x-p.mo.momx, p.mo.y-p.mo.momy), FixedHypot(p.mo.momx, p.mo.momy)/5)
				if not P_PlayerInPain(p) and not (p.mo.eflags & MFE_SPRUNG)
					p.mo.momz = $/2
					p.mo.state = S_PLAY_FALL
				end
				S_StopSoundByID(p.mo, sfx_blakwo)
				if p.blake.follower1 and p.blake.follower1.valid and p.blake.follower1.health //reset follower garbage
					p.blake.follower1.momx = p.mo.momx
					p.blake.follower1.momy = p.mo.momy
					p.blake.follower1.momz = p.mo.momz+p.mo.momz/6
					p.blake.follower1.state = S_PLAY_FALL
				end
				if p.blake.follower2 != nil
					p.blake.follower2.momx = p.mo.momx
					p.blake.follower2.momy = p.mo.momy
					p.blake.follower2.momz = p.mo.momz+p.mo.momz/5
					p.blake.follower2.state = S_PLAY_FALL
				end
				p.blake.follower1 = nil
				p.blake.follower2 = nil
			end
		else
				p.blake.follower1 = nil
				p.blake.follower2 = nil
		end
end)
addHook("PreThinkFrame", do
	for p in players.iterate
		--print(P_IsValidSprite2(p.mo, SPR2_GRND))
		//bot shite
		if p and p.mo and p.mo.valid and p.mo.health and p.mo.skin == "blake" and p.bot
			local p1 = players[0]
			if p1 and p1.mo and p1.mo.valid and p1.mo.health
				if P_AproxDistance(p.mo.z-p1.mo.z,P_AproxDistance(p.mo.x-p1.mo.x, p.mo.y-p1.mo.y)) <= p.mo.radius*3 and P_IsObjectOnGround(p1.mo) and P_IsObjectOnGround(p.mo) and p1.speed <= 2*p1.mo.scale and p.speed <= 2*p.mo.scale
					--print(leveltime)
					if (p1.cmd.buttons & BT_JUMP)
						p.blake.botjump = 45
					end
					//flight indicator
					if not (p.blake.botoverlay and p.blake.botoverlay.valid)
						local overlay = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_OVERLAY)
						overlay.state = S_FLIGHTINDICATOR
						overlay.target = p.mo
						p.blake.botoverlay = overlay
						--print("spawned")
					else
						P_MoveOrigin(p.blake.botoverlay, p.mo.x, p.mo.y, p.mo.z)
						--print("teleported")
					end
				elseif p.blake.botoverlay and p.blake.botoverlay.valid
					--print("removed")
					P_RemoveMobj(p.blake.botoverlay)
				end
				if p.blake.dragon > 0 and p.blake.dragon <= 25 --control jank
					p.mo.angle = p1.mo.angle
					p.cmd.angleturn = p1.cmd.angleturn
					p.cmd.sidemove = p1.cmd.sidemove
					p.cmd.forwardmove = p1.cmd.forwardmove
				end
			end
			if p.blake.botjump > 0 and (p.pflags & PF_JUMPED) and p.mo.momz*P_MobjFlip(p.mo) < 0
				p.blake.botjump = 0
				p.cmd.buttons = $|BT_JUMP
			end
			p.blake.botjump = max($-1, 0)
		end
		if p.blakecarry != nil and p.blakecarry > 0
			p.powers[pw_carry] = CR_PLAYER
			if p.blakecarry == 1
				p.powers[pw_carry] = CR_NONE
			end
			p.blakecarry = $-1
		end
	end
end)
local slashstates = {}

slashstates[0] = S_PLAY_BLAKE_SLASH1

slashstates[1] = S_PLAY_BLAKE_SLASH2

slashstates[2] = S_PLAY_BLAKE_DASH
//slash 'n dash and also bird
addHook("SpinSpecial", function(p)
	if not (p and p.mo and p.mo.valid and p.mo.health and p.mo.skin == "blake") return end
	if p.blake.slashstate <=2 and not (p.pflags & PF_SPINDOWN) and not P_PlayerInPain(p) and p.mo.state != S_PLAY_BLAKE_DASH and not (p.powers[pw_carry]) and not (p.exiting) and not (p.pflags & PF_SLIDING)
		if not (p.pflags & PF_JUMPED) --if you haven't jumped, do melee
			p.mo.state = slashstates[p.blake.slashstate]
			p.panim = PA_DASH
			if p.blake.slashstate == 2 --if slashstate is 2, then you ain't slashin', you dashin'
					S_StartSound(p.mo, sfx_zoom)
			else
					S_StartSound(p.mo, sfx_ngskid)
			end
			if not (p.mo.flags2 & MF2_TWOD) and not (twodlevel)
				p.blake.dashangle = p.cmd.angleturn<<16 + R_PointToAngle2(0, 0, p.cmd.forwardmove*FRACUNIT, -p.cmd.sidemove*FRACUNIT)
			else
				p.blake.dashangle = p.mo.angle
			end
			if p.cmd.forwardmove != 0 or p.cmd.sidemove != 0
				P_InstaThrust(p.mo, p.blake.dashangle, 48*p.mo.scale)
			else
				P_InstaThrust(p.mo, p.blake.dashangle, max(FixedHypot(p.mo.momx, p.mo.momy), 20*p.mo.scale))
			end
			p.drawangle = p.blake.dashangle
			p.blake.slashstate = $+1
			p.blake.slashtime = 35
			if p.cmd.forwardmove == 0 and p.cmd.sidemove == 0 --hate this game
				if not (p.mo.flags2 & MF2_TWOD) and not (twodlevel)
					p.cmd.forwardmove = 1
				else
					p.cmd.sidemove = 1					
				end
			end
		else --otherwise, BIRD UP
			if p.blake.bird == 0
				p.blake.bird = 1
				if p.blake.dragon > 0
					p.blake.dragon = max($, 25)
				end
				p.blake.dashangle = p.mo.angle
				--P_InstaThrust(p.mo, p.blake.dashangle, 54*p.mo.scale)
				p.drawangle = p.blake.dashangle
				local bird = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_BLAKE_SHADOWBIRD)
				S_StartSound(p.mo, sfx_blaksp)
				bird.target = p.mo
				bird.lifetime = 0
			end
		end
	end
end)
//dragon dash
addHook("AbilitySpecial", function(p)
	if not (p and p.mo and p.mo.valid and p.mo.health and p.mo.skin == "blake") return end
	if not P_PlayerInPain(p) and not (p.powers[pw_carry])
		if p.blake.dragon == 0
			p.blake.dragon = 1
			p.blake.dashangle = p.mo.angle
			--P_InstaThrust(p.mo, p.blake.dashangle, 54*p.mo.scale)
			p.drawangle = p.blake.dashangle
			local dragon = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_BLAKE_SHADOWDRAGON)
			S_StartSound(p.mo, sfx_blaksp)
			dragon.target = p.mo
			dragon.lifetime = 0
		end
	end
end)
//dragon visuals
addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.health
		if mo.target and mo.target.valid and mo.target.health
				local zadd
				if P_MobjFlip(mo.target) == 1
					zadd = 0
				else
					zadd = mo.target.height
					--print(leveltime)
				end
			if mo.lifetime >= 10 --waited long enough for the dragon to fully spawn
				P_MoveOrigin(mo, mo.target.x+P_ReturnThrustX(mo, mo.target.player.blake.dragonangle, 55*mo.target.scale), mo.target.y+P_ReturnThrustY(mo, mo.target.player.blake.dragonangle, 55*mo.target.scale), mo.target.z+zadd)
				local spooky = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_BLAKE_AFTERIMAGE) --fake ghostmobjs
				spooky.angle = mo.angle
				spooky.state = mo.state
				spooky.scale = mo.scale-mo.scale/8
				spooky.sprite = mo.sprite
				spooky.frame = mo.frame|FF_TRANS40|FF_FULLBRIGHT
				spooky.blendmode = AST_SUBTRACT
				spooky.color = SKINCOLOR_SUPERPURPLE3
				spooky.colorized = true
				spooky.destscale = 0
				spooky.fuse = 10
				P_SetOrigin(spooky, spooky.x+P_RandomRange(5, -5)*mo.scale, spooky.y+P_RandomRange(5, -5)*mo.scale, spooky.z+P_RandomRange(5, -5)*mo.scale)
				for i = 1, 8 do
					local flame = P_SpawnMobjFromMobj(mo, P_RandomRange(15, -15)*mo.scale, P_RandomRange(15, -15)*mo.scale, P_RandomRange(35, 0)*mo.scale, MT_FLAMEPARTICLE)
					flame.colorized = true
					flame.color = SKINCOLOR_PASTEL
					flame.blendmode = AST_SUBTRACT
				end
			else
				P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z+zadd)
			end
			if mo.lifetime == 10
				mo.state = S_SHADOWDRAGON_HEAD
			end
			mo.angle = mo.target.player.blake.dragonangle
			mo.lifetime = $+1
			if mo.target.player.blake.dragon == 0 or mo.target.player.blake.dragon == 26
				local ghost = P_SpawnGhostMobj(mo)
				ghost.momx = mo.target.momx
				ghost.momz = mo.target.momz
				ghost.momy = mo.target.momy
				P_RemoveMobj(mo)
			end
		else
			P_RemoveMobj(mo)
		end
	end
end, MT_BLAKE_SHADOWDRAGON)
//dragon visuals part 2
addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.health
		if mo.target and mo.target.valid and mo.target.health
				local zadd
				if P_MobjFlip(mo.target) == 1
					zadd = 0
				else
					zadd = mo.target.height
					--print(leveltime)
				end
			//elseif chain because i can't be assed to do this better
			if mo.num == 1
				P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z+zadd)
			elseif mo.num == 2
				P_MoveOrigin(mo, mo.target.player.blake.trail1x, mo.target.player.blake.trail1y, mo.target.player.blake.trail1z+zadd)
			elseif mo.num == 3
				P_MoveOrigin(mo, mo.target.player.blake.trail2x, mo.target.player.blake.trail2y, mo.target.player.blake.trail2z+zadd)
			end
			local spooky = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_BLAKE_AFTERIMAGE) --fake ghostmobjs
			spooky.angle = mo.angle
			spooky.state = mo.state
			spooky.scale = mo.scale-mo.scale/8
			spooky.sprite = mo.sprite
			spooky.frame = mo.frame|FF_TRANS40|FF_FULLBRIGHT
			spooky.blendmode = AST_SUBTRACT
			spooky.color = SKINCOLOR_SUPERPURPLE3
			spooky.colorized = true
			spooky.destscale = 0
			spooky.fuse = 10
			P_SetOrigin(spooky, spooky.x+P_RandomRange(5, -5)*mo.scale, spooky.y+P_RandomRange(5, -5)*mo.scale, spooky.z+P_RandomRange(5, -5)*mo.scale)
			/*for i = 1, 8 do
				local flame = P_SpawnMobjFromMobj(mo, P_RandomRange(15, -15)*mo.scale, P_RandomRange(15, -15)*mo.scale, P_RandomRange(15, -15)*mo.scale, MT_FLAMEPARTICLE)
				flame.colorized = true
				flame.color = SKINCOLOR_PASTEL
				flame.blendmode = AST_SUBTRACT
			end*/
			if mo.lifetime == 10
				mo.state = S_SHADOWDRAGON_HEAD
			end
			mo.angle = mo.target.player.blake.dragonangle
			if mo.target.player.blake.dragon == 0 or mo.target.player.blake.dragon == 26
				local ghost = P_SpawnGhostMobj(mo)
				ghost.momx = mo.target.momx
				ghost.momz = mo.target.momz
				ghost.momy = mo.target.momy
				P_RemoveMobj(mo)
			end
		else
			P_RemoveMobj(mo)
		end
	end
end, MT_BLAKE_SHADOWDRAGON_TAIL)
//bird visuals
addHook("MobjThinker", function(mo)
	if mo and mo.valid and mo.health
		if mo.target and mo.target.valid and mo.target.health
				local zadd
				if P_MobjFlip(mo.target) == 1
					zadd = 0
				else
					zadd = mo.target.height
					--print(leveltime)
				end
			if mo.lifetime >= 10 --waited long enough for the bird to fully spawn
				P_MoveOrigin(mo, mo.target.x+P_ReturnThrustX(mo, mo.target.player.blake.dashangle, 5*mo.target.scale), mo.target.y+P_ReturnThrustY(mo, mo.target.player.blake.dashangle, 5*mo.target.scale), mo.target.z+zadd)
				local spooky = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_BLAKE_AFTERIMAGE) --fake ghostmobjs
				spooky.angle = mo.angle
				spooky.state = mo.state
				spooky.scale = mo.scale-mo.scale/8
				spooky.sprite = mo.sprite
				spooky.frame = mo.frame|FF_TRANS40|FF_FULLBRIGHT
				spooky.blendmode = AST_SUBTRACT
				spooky.color = SKINCOLOR_SUPERPURPLE3
				spooky.colorized = true
				spooky.destscale = 0
				spooky.fuse = 10
				P_SetOrigin(spooky, spooky.x+P_RandomRange(5, -5)*mo.scale, spooky.y+P_RandomRange(5, -5)*mo.scale, spooky.z+P_RandomRange(5, -5)*mo.scale)
				for i = 1, 8 do
					local flame = P_SpawnMobjFromMobj(mo, P_RandomRange(15, -15)*mo.scale, P_RandomRange(15, -15)*mo.scale, P_RandomRange(15, -15)*mo.scale, MT_FLAMEPARTICLE)
					flame.colorized = true
					flame.color = SKINCOLOR_PASTEL
					flame.blendmode = AST_SUBTRACT
				end
			else
				P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z+zadd)
			end
			if mo.lifetime == 10
				mo.state = S_SHADOWBIRD
			end
			mo.angle = mo.target.player.blake.dashangle
			mo.lifetime = $+1
			if mo.target.player.blake.bird == 0 or mo.target.player.blake.bird == 26
				local ghost = P_SpawnGhostMobj(mo)
				ghost.momx = mo.target.momx
				ghost.momz = mo.target.momz
				ghost.momy = mo.target.momy
				P_RemoveMobj(mo)
			end
		else
			P_RemoveMobj(mo)
		end
	end
end, MT_BLAKE_SHADOWBIRD)
local blake_attackstates = {} --just makes things marginally easier if i do it this way
blake_attackstates[S_PLAY_BLAKE_SLASH1] = true
blake_attackstates[S_PLAY_BLAKE_SLASH2] = true
blake_attackstates[S_PLAY_BLAKE_DASH] = true
blake_attackstates[S_PLAY_BLAKE_RIDE] = true

addHook("PlayerCanDamage", function(p)
	if not (p and p.mo and p.mo.valid and p.mo.health and p.mo.skin == "blake") return end
	if blake_attackstates[p.mo.state]
		return true
	end
end)


//break breakable floors and walls
//...i could use PW_STRONG now...
//But I don't want to. 
//
//
//Fuck you.
local function CheckAndCrumble2(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.momz + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z + mo.momz > fof.topheight continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
end

addHook("PlayerThink", function(p)
  if not p.mo return end
  if p.mo.skin != "blake" return end
  if not (blake_attackstates[p.mo.state]) return end
	CheckAndCrumble2(p.mo, p.mo.subsector.sector)
end)

addHook("MobjLineCollide", function(mo, line)
  if not mo.player return end
  if mo.skin != "blake" return end
  if not (blake_attackstates[mo.state]) return end
  for _, sec in ipairs({line.frontsector, line.backsector})
    CheckAndCrumble2(mo, sec)
  end
end, MT_PLAYER)
local spikekiller = function(thing, tmthing)
	if not (thing and thing.valid and tmthing and tmthing.valid) return end
	if tmthing.player and tmthing.skin == "blake" and tmthing.state == S_PLAY_BLAKE_DASH
	and (abs(thing.z - tmthing.z) <= 60*tmthing.scale)
		if tmthing.z >= thing.z-tmthing.height and tmthing.z <= thing.z+thing.height+tmthing.height
			P_KillMobj(thing, tmthing)
			return true
		end
	end
end
addHook("MobjCollide", function(thing, tmthing) spikekiller(thing, tmthing) end, MT_SPIKE)
addHook("MobjCollide", function(thing, tmthing) spikekiller(thing, tmthing) end, MT_WALLSPIKE)